unit Client;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, Buttons, ExtCtrls, WSocket, HttpProt, ShellApi;

Const
  cExeName_Version = 'DynClient';
  VERSION = '2.2';

  cInitURL = 'http://???/gnudip/cgi-bin/gdipupdt.cgi';
  cInitDomain = '';
  cInitURLUpdate = 'http://www.andrearusso.it/Client/versione.php';
  cLocalIP = '127.0.0.1';

type
  TFClient = class(TForm)
    lblDomain: TLabel;
    lblUser: TLabel;
    lblPassword: TLabel;
    EditDomain: TEdit;
    EditUserName: TEdit;
    EditPassword: TEdit;
    StatusBar: TStatusBar;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    RadioGroup: TRadioGroup;
    chkSavePassword: TCheckBox;
    lblURL: TLabel;
    Bevel1: TBevel;
    TimerIP: TTimer;
    lblIPAddress: TLabel;
    HttpCli1: THttpCli;
    btnOk: TButton;
    HttpUpdate: THttpCli;
    mnuUtility: TMenuItem;
    mnuVerificaAggiornamenti: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    chkAutoUpdate: TCheckBox;
    PopupMenuTrayIcon: TPopupMenu;
    popupOpen: TMenuItem;
    popupExit: TMenuItem;
    TimerOnStartUp: TTimer;
    mnuSetupServerUR: TMenuItem;
    UpdateIP1: TMenuItem;
    MettiOffline1: TMenuItem;
    N1: TMenuItem;
    procedure mnuExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblURLClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure TimerIPTimer(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure mnuVerificaAggiornamentiClick(Sender: TObject);
    procedure chkAutoUpdateClick(Sender: TObject);
    procedure popupExitClick(Sender: TObject);
    procedure popupOpenClick(Sender: TObject);
    procedure TimerOnStartUpTimer(Sender: TObject);
    procedure mnuSetupServerURClick(Sender: TObject);
    procedure UpdateIP1Click(Sender: TObject);
    procedure MettiOffline1Click(Sender: TObject);
  private
    { Private declarations }
    sProxy : string;
    sProxyPort : string;
    sExePath : string;
    bWriteFile : boolean;
    sCurrentIP : string;
    IconData : TNotifyIconData;
    bStartUp : boolean;
    sURLUpdate : string;
    
    Procedure WriteIPAddress;
    Procedure UpdateData(nOperation: byte; bAutoExit: boolean);
    Procedure InitFileIni;
    function  ExtractMetaTag(s : string; sPage : string): string;
    function  Get_Local_IPAddr : string;
    procedure ChangeToolTip(s : string);
    procedure OnSystemTry(Sender: TObject);
    procedure AddIcon;
    procedure GoTray;
    procedure ChangeURLUpdate;
  public
    { Public declarations }
        crHandCursor : integer;
        cVersion : string;
        sExeName : string;
        gIDLanguage: word;
        gbEnglishMsg : boolean;
        sURL : string;

        Procedure OpenBrowser(sURL: string);
        procedure WndProc(var Msg : TMessage); override;
  end;

var
  FClient: TFClient;
  IniFileName: string;

implementation

{$R *.DFM}

uses IniFiles, About, Winsock, MD5, URLSetup;

Function ConvertToMD5(s: string): string;
begin
  Result := lowercase(GetMD5(@s[1], Length(s) - 1));
end;

function TFClient.Get_Local_IPAddr : string;
  type
    TaPInAddr = array [0..10] of PInAddr;
    PaPInAddr = ^TaPInAddr;
  var
    phe : PHostEnt;
    pptr : PaPInAddr;
    Buffer : array [0..63] of char;
    I : Integer;
    GInitData : TWSADATA;
    sIP : string;
    sMsgWaitingAutoUpdate : string;
begin

  if gbEnglishMsg then
    sMsgWaitingAutoUpdate := 'Waiting for auto update.'
  else
    sMsgWaitingAutoUpdate := 'In attesa di riconnessione automatica.';

  try
    WSAStartup($101, GInitData);
    Result := '';
    GetHostName(Buffer, SizeOf(Buffer));
    phe := GetHostByName(buffer);
    if phe = nil then Exit;
    pptr := PaPInAddr(Phe^.h_addr_list);
    i := 0;
    result := '';
    while pptr^[I] <> nil do
    begin
      sIP:=StrPas(inet_ntoa(pptr^[I]^));

      if chkAutoUpdate.State = cbChecked then
      begin
        if I=0 then
        begin
          if (sCurrentIP=cLocalIP) and (sIP<>cLocalIP) then
          begin
            TimerIP.enabled := false;
            UpdateData(0,false);
            TimerIP.enabled := true;
          end
          else
            if sIP=cLocalIP then
            begin
              sCurrentIP := cLocalIP;
              StatusBar.SimpleText := sMsgWaitingAutoUpdate;
              IconData.hIcon := LoadIcon(HInstance, 'WAIT_UPDATE');
              ChangeToolTip(StatusBar.SimpleText);
            end;
        end;
      end;

      result:= result + sIP + ' ';
      Inc(I);
    end;
  finally WSACleanup; end;
end;

Procedure TFClient.WriteIPAddress;
Var
 s : string;
begin
  if gbEnglishMsg then
    s := 'Local IP:'
  else
    s := 'IP Locale: ';

  lblIPAddress.Caption := s + Get_Local_IPAddr;
end;

procedure TFClient.mnuExitClick(Sender: TObject);
begin
   TimerIp.Enabled := false;
   Close;
end;

procedure TFClient.FormClose(Sender: TObject; var Action: TCloseAction);
var
    IniFile : TIniFile;
    s : string;
    i : smallint;
begin
    IniFile := TIniFile.Create(IniFileName);
    try
      IniFile.WriteString('Data', 'UserName', trim(EditUserName.Text));
      IniFile.WriteString('Data', 'Domain', trim(EditDomain.Text));
      IniFile.WriteString('Data', 'URL', sURL);
      IniFile.WriteString('Proxy', 'Name', sProxy);
      IniFile.WriteString('Proxy', 'Port', sProxyPort);
      IniFile.WriteString('Update', 'URLUpdate', sURLUpdate);

      s:='';
      if chkSavePassword.State = cbChecked then
        s:= trim(EditPassword.Text);

      IniFile.WriteString('Data', 'Password', s);

      i:=0;
      if chkSavePassword.State = cbChecked then i:=1;

      IniFile.WriteInteger('Preference', 'SavePassword', i);

      i:=0;
      if chkAutoUpdate.State = cbChecked then i:=1;

      IniFile.WriteInteger('Preference', 'AutoUpdate', i);
    finally
      IniFile.Free;
    end;
    Shell_NotifyIcon(NIM_DELETE, @IconData);
    Application.ProcessMessages;
    Application.Terminate;
end;

procedure TFClient.lblURLClick(Sender: TObject);
begin
  OpenBrowser('http://www.andrearusso.it/');;
end;

Procedure TFClient.OpenBrowser(sURL: string);
begin
  ShellExecute(0,
             nil,
             PChar(sURL),
             nil,
             nil,
             SW_SHOWNORMAL);
end;

procedure TFClient.mnuAboutClick(Sender: TObject);
begin
  If FAbout = nil then
  begin
     FAbout := TFAbout.create(self);
     FAbout.ShowModal;
  end;
end;

procedure TFClient.TimerIPTimer(Sender: TObject);
begin
  WriteIPAddress;
  //beep;
end;

Procedure TFClient.UpdateData(nOperation: byte; bAutoExit: boolean);
var
    DataIn  : TMemoryStream;
    DataIn2  : TMemoryStream;
    sQuery     : String;
    bData : boolean;
    bError : boolean;
    s : string;
    F: TextFile;
    Receive : TStringList;
    Receive2 : TStringList;
    sSalt, sSign, sTime : string;
    sString : string;
    sResult : string;
    sAddr : string;

    sMsgConnecting : string;
    sMsgReceive : string;
    sMsgSending : string;
    sMsgReceive2 : string;
    sMsgSuccessfulUpdate : string;
    sMsgSuccessfulOffline : string;
    sMsgInvalidLogin : string;
    sMsgError : string;
begin
  if gbEnglishMsg then
     begin
      sMsgConnecting := 'Connecting...';
      sMsgReceive := 'Data received.';
      sMsgSending := 'Sending data...';
      sMsgReceive2 := 'Data received.';
      sMsgSuccessfulUpdate := 'Successful update (IP= %s).';
      sMsgSuccessfulOffline := 'Successful offline.';
      sMsgInvalidLogin := 'Invalid login.';
      sMsgError := 'Error: ';
     end
    else
     begin
      sMsgConnecting := 'Invio dei dati al server.';
      sMsgReceive := 'Ricevuti i dati per l''autenticazione.';
      sMsgSending := 'Invio della risposta al server.';
      sMsgReceive2 := 'Ricevuti i dati per l''autenticazione.';
      sMsgSuccessfulUpdate := 'IP aggiornato con successo (IP= %s).';
      sMsgSuccessfulOffline := 'Dominio impostato come offline.';
      sMsgInvalidLogin := 'Errore: dati non corretti.';
      sMsgError := 'Errore: ';
     end;

    if bWriteFile then
    begin
      AssignFile(F,sExePath + 'Result.txt');
      Rewrite(F);
    end;

    bData := false;
    bError := true;
    DataIn  := TMemoryStream.Create;
    try
      Screen.cursor := crHourGlass;
      TimerIp.Enabled := false;

      httpcli1.RcvdStream := DataIn;
      httpcli1.ProxyPort  := '80';
      HttpCli1.URL        := sURL;

      HttpCli1.ProxyPort := sProxyPort;
      HttpCli1.Proxy := sProxy;
      HttpCli1.Sender := cExeName_Version + ' ' + VERSION;
      HttpCli1.Reference := cExeName_Version + ' ' + VERSION;

      btnOk.Enabled := FALSE;
      try
        StatusBar.SimpleText := sMsgConnecting;
        IconData.hIcon := LoadIcon(HInstance, 'WAIT_UPDATE');
        ChangeToolTip(StatusBar.SimpleText);
        try
          httpcli1.Get;
          bData := true;
        except
           on E: EHttpException do
             begin
               s := IntToStr(httpcli1.StatusCode) + ' ' + httpcli1.ReasonPhrase;
               StatusBar.SimpleText := sMsgError + s + '.';
               IconData.hIcon := LoadIcon(HInstance, 'NO_UPDATE');
               ChangeToolTip(StatusBar.SimpleText);
               if bWriteFile then
                 Write(F,s);
             end;
           else
              raise;
         end;
    finally
        if bData then
        begin
          Receive := TStringList.Create;
          try
            DataIn.Seek(0, 0);
            Receive.LoadFromStream(DataIn);
            if Length(Receive.Text)>0 then
            begin
               StatusBar.SimpleText := sMsgReceive;
               ChangeToolTip(StatusBar.SimpleText);

               sSalt := ExtractMetaTag('salt',Receive.Text);
               sTime := ExtractMetaTag('time',Receive.Text);
               sSign := ExtractMetaTag('sign',Receive.Text);

               sString := ConvertToMD5(trim(EditPassword.Text)+#0);
               sString := sString + '.' + sSalt;
               sString := ConvertToMD5(sString+#0);

               bData := false;
               bError := true;
               DataIn2  := TMemoryStream.Create;
               Receive2 := TStringList.Create;
               try
                 Screen.cursor := crHourGlass;
                 sQuery  := 'salt=' + sSalt +
                   '&time=' + sTime +
                   '&sign=' + sSign +
                   '&user=' + Trim(EditUserName.Text) +
                   '&domn=' + Trim(EditDomain.Text) +
                   '&pass=' + sString;

                 // reqc
                 // 0 - update passing IP address
                 // 2 - update asking for IP address
                 // 1 - offline

                 if nOperation=0 then
                   sQuery := sQuery + '&reqc=2' //update asking for IP address
                 else
                   sQuery := sQuery + '&reqc=1'; // offline

                 httpcli1.RcvdStream := DataIn2;
                 httpcli1.ProxyPort  := '80';
                 HttpCli1.URL        := sURL+'?'+sQuery;

                 HttpCli1.ProxyPort := sProxyPort;
                 HttpCli1.Proxy := sProxy;
                 HttpCli1.Sender := cExeName_Version + ' ' + VERSION;
                 HttpCli1.Reference := cExeName_Version + ' ' + VERSION;
                 try
                   StatusBar.SimpleText := sMsgSending;
                   ChangeToolTip(StatusBar.SimpleText);
                   try
                     httpcli1.Get;
                     bData := true;
                   except
                     on E: EHttpException do
                       begin
                         s := IntToStr(httpcli1.StatusCode) + ' ' + httpcli1.ReasonPhrase;
                         StatusBar.SimpleText := sMsgError + s + '.';
                         IconData.hIcon := LoadIcon(HInstance, 'NO_UPDATE');
                         ChangeToolTip(StatusBar.SimpleText);
                         if bWriteFile then
                            Write(F,s);
                       end;
                     else
                       raise;
                   end;  // end try except
                 finally
                   if bData then
                   begin
                     DataIn2.Seek(0, 0);
                     Receive2.LoadFromStream(DataIn2);

                     if Length(Receive2.Text)>0 then
                     begin
                       StatusBar.SimpleText := sMsgReceive2;
                       ChangeToolTip(StatusBar.SimpleText);
                       sResult := ExtractMetaTag('retc',Receive2.Text);
                       sAddr := ExtractMetaTag('addr',Receive2.Text);

                       // retc
                       // 0 - successful update
                       // 2 - successful offline
                       // 1 - invalid login (or other problem)

                       if (sResult='0') or (sResult='2') then
                         begin
                          bError := false;
                          if bWriteFile then
                             Write(F,'OK');

                          IconData.hIcon := LoadIcon(HInstance, 'YES_UPDATE');
                          if sResult='0' then
                          begin
                            StatusBar.SimpleText := Format(sMsgSuccessfulUpdate,[sAddr]);
                            ChangeToolTip(StatusBar.SimpleText);
                            sCurrentIP := sAddr;
                          end
                          else
                          begin
                            StatusBar.SimpleText := sMsgSuccessfulOffline;
                            ChangeToolTip(StatusBar.SimpleText);
                          end;
                         end
                      else
                         begin
                           StatusBar.SimpleText := sMsgInvalidLogin;
                           IconData.hIcon := LoadIcon(HInstance, 'NO_UPDATE');
                           ChangeToolTip(StatusBar.SimpleText);
                           ChkAUtoUpdate.State := cbUnchecked;
                           
                           if bWriteFile then
                             Write(F,sMsgError +'Invalid Login');
                         end;
                     end; // length(sReceive2)
                   end; //end if bData
                 end; // end try invio risposta
               finally
                 Receive2.Free;
                 DataIn2.Free;
               end;
             end; // end if length(Receive)>0
           finally
             Receive.Free;
           end;
         end; // end if bData
         btnOk.Enabled := TRUE;
     end;
    finally
      Screen.cursor := crDefault;
      DataIn.Free;
      if bWriteFile then
         CloseFile(F);
       if bAutoExit then
        begin
         if bWriteFile or not(bWriteFile or bError) then
          begin
            TimerIp.Enabled := false;
            FClient.close;
          end;
        end
      else
        TimerIp.Enabled := true;
    end;
end;

function TFClient.ExtractMetaTag(s : string; sPage : string): string;
var
 iPos : smallint;
 sSearch : string;
 iStart : smallint;
 sStr : string;
begin
  Result := '';
  sSearch := '<meta name="'+s+'" content="';
  iPos := Pos(sSearch,sPage);

  if iPos>0 then
  begin
    iStart := length(sSearch)+iPos;
    sStr := Copy(sPage,iStart,length(sPage)-iStart);
    iPos := Pos('"',sStr);
    if iPos>0 then
    begin
      sStr := Copy(sStr,1,iPos-1);
      Result := sStr;
    end;
  end;
end;

procedure TFClient.btnOkClick(Sender: TObject);
begin
    if (Pos('??',sURL)>0) then
      ChangeURLUpdate;
      
    UpdateData(RadioGroup.ItemIndex,false);
end;

Procedure TFClient.InitFileIni;
var
    IniFile : TIniFile;
begin
    IniFile := TIniFile.Create(IniFileName);
    try
      IniFile.WriteString('Data', 'UserName', 'User');
      IniFile.WriteString('Data', 'Domain', cInitDomain);
      IniFile.WriteString('Data', 'URL', cInitURL);
      IniFile.WriteString('Data', 'Password', ' ');
      IniFile.WriteInteger('Preference', 'SavePassword', 0);
      IniFile.WriteString('Proxy', 'Name', '');
      IniFile.WriteString('Proxy', 'Port', '');
      IniFile.WriteString('Update', 'URLUpdate', cInitURLUpdate);
    finally
      IniFile.Free;
    end;
end;
procedure TFClient.FormCreate(Sender: TObject);
var
  IniFile : TIniFile;
  sParam : string;
  sMsg, sTitle : string;
  i : byte;
begin
     Screen.cursor := crHourGlass;
     bStartUp := true;
     Application.OnMinimize := OnSystemTry;
     IconData.hIcon := Application.Icon.Handle;
     AddIcon;

     sCurrentIP:=cLocalIP;

     cVersion := VERSION;
     crHandCursor := 5;
     Screen.Cursors[crHandCursor] := LoadCursor(HInstance, 'Hand');
     lblURL.Cursor := crHandCursor;
     lblURL.Hint := 'Anche il tuo pc pu diventare un server !';
     MainMenu1.Items[1].Caption := 'U&tilit';

     gIDLanguage := windows.GetUserDefaultLangID();

     gbEnglishMsg := false;

     if not((gIDLanguage=$410) or (gIDLanguage=$810)) then //Italian Standard and Italian for switzerland
     begin
      gbEnglishMsg := true;

      FClient.Caption := 'GnuDIP Client for Windows';
      lblUser.Caption := '&User';
      lblPassword.Caption := 'Pass&word';
      lblDomain.Caption := '&Domain';
      RadioGroup.Caption := '&Mode';
      RadioGroup.Items.Text := 'U&pdate IP' + #13#10 + 'O&ffline';
      chkSavePassword.Caption := '&Save password';
      chkAutoUpdate.Caption := 'Au&to Update';
      StatusBar.SimpleText := 'Ready.';
      ChangeToolTip(StatusBar.SimpleText);

      MainMenu1.Items[0].Items[0].Caption := 'E&xit';
      MainMenu1.Items[1].Caption := 'U&tility';
      MainMenu1.Items[1].Items[0].Caption := 'Server GnuDip URL';
      MainMenu1.Items[1].Items[1].Caption := 'Searching for updates';
      MainMenu1.Items[2].Items[0].Caption := '&About';

      lblIPAddress.Caption := 'Local IP:';

      PopupMenuTrayIcon.Items[0].Caption := 'Open GnuDIP Client';
      PopupMenuTrayIcon.Items[1].Caption := 'Update IP';
      PopupMenuTrayIcon.Items[2].Caption := 'Offline';
      PopupMenuTrayIcon.Items[3].Caption := '-';
      PopupMenuTrayIcon.Items[4].Caption := 'Exit';
     end;

    bWriteFile := false;
    sExePath := ExtractFilePath(Application.ExeName);
    sExeName := LowerCase(ExtractFileName(Application.ExeName));

    IniFileName := ExtractFilePath(Application.ExeName) + Copy(sExeName,1,length(sExeName)-3) +'ini';

    if not(FileExists(IniFileName)) then
        InitFileIni;

    IniFile  := TIniFile.Create(IniFileName);

    try
      sURL := IniFile.ReadString('Data', 'URL',  cInitURL);
      EditUserName.Text := IniFile.ReadString('Data', 'UserName',  'User');
      EditPassword.Text := IniFile.ReadString('Data', 'Password',  ' ');
      EditDomain.Text := IniFile.ReadString('Data', 'Domain',  cInitDomain);

      if IniFile.ReadInteger('Preference', 'SavePassword', 0)=1 then
        chkSavePassword.State := cbChecked
      else
        chkSavePassword.State := cbUnchecked;

      if IniFile.ReadInteger('Preference', 'AutoUpdate', 0)=1 then
        chkAutoUpdate.State := cbChecked
      else
        chkAutoUpdate.State := cbUnchecked;

      sProxyPort := IniFile.ReadString('Proxy', 'Port', '');
      sProxy := IniFile.ReadString('Proxy', 'Name', '');

      sURLUpdate := IniFile.ReadString('Update', 'URLUpdate',  cInitURLUpdate);

      if ParamCount=0 then
        begin
          if chkAutoUpdate.State = cbChecked then
          begin
            WindowState := wsMinimized;
            Application.ProcessMessages;
            TimerOnStartUp.Enabled := true;
          end;
        end
      else
        begin
          i := 1;
          if UpperCase(ParamStr(1)) = '-F' then
          begin
            bWriteFile := true;
            i := 2;
          end;

          if ParamCount=i then
          begin
            sParam := UpperCase(ParamStr(i));
            if sParam = 'UPDATEIP' then
               begin
               UpdateData(0,true);
               end
            else
              if sParam = 'OFFLINE' then
                begin
                  UpdateData(1,true);
                end
              else
                begin
                   sMsg := 'Parametri di avvio non corretti.' + #13#10#13#10 + 'Uso: ' + sExeName + ' [-F] [UpdateIP | Offline]';
                   sTitle := 'Attenzione';
                   MessageBox(0,PChar(sMsg),PChar(sTitle),mb_ok);
                end;
        end;
      end;
    finally
      IniFile.Free;
    end;

    Screen.cursor := crDefault;
end;

procedure TFClient.FormActivate(Sender: TObject);
begin
  Application.ProcessMessages;
  if not(bWriteFile) then
  begin
    if chkAutoUpdate.State=cbUnChecked then
      begin
        WriteIPAddress;
        TimerIP.enabled := true;
      end
    else
      if bStartUp then
      begin
        WindowState := wsMinimized;
        Application.ProcessMessages;
        TimerOnStartUp.Enabled := true;
      end;
  end;
end;

procedure TFClient.FormDeactivate(Sender: TObject);
begin
   TimerIP.Enabled := false;
end;

procedure TFClient.mnuVerificaAggiornamentiClick(Sender: TObject);
var
  DataIn  : TMemoryStream;
  bData : boolean;
  sMsg : string;
  p,q,r : PChar;
  sData : string;

  sMsgConnecting : string;
  sMsgError : string;
  sMsgNoUpdateAvailable : string;
  sMsgUpdateAvailable : string;
  sMsgTitle : string;
begin
if gbEnglishMsg then
  begin
    sMsgError := 'Error: ';
    sMsgConnecting := 'Connecting...';
    sMsgNoUpdateAvailable := 'No update available.';
    sMsgUpdateAvailable := 'Your current version is the %s.' + #13#10#13#10
       +'Is is available upgrade to version %s.';
    sMsgTitle := 'Searching for updates';
  end
else
  begin
    sMsgError := 'Errore: ';
    sMsgConnecting := 'Verifica in corso.';
    sMsgNoUpdateAvailable :='Nessun aggiornamento disponibile.';
    sMsgUpdateAvailable := 'La versione corrente  la %s.' + #13#10#13#10
      +' disponibile l''aggiornamento alla versione %s.';
    sMsgTitle := 'Verifica aggiornamenti';
  end;

    bData := false;

    TimerIP.Enabled := false;

    DataIn  := TMemoryStream.Create;

    HttpUpdate.URL        := sURLUpdate;
    HttpUpdate.RcvdStream := DataIn;
    HttpUpdate.ProxyPort  := '80';

    HttpUpdate.ProxyPort := sProxyPort;
    HttpUpdate.Proxy := sProxy;
    HttpUpdate.Sender := cExeName_Version + ' ' + VERSION;
    HttpUpdate.Reference := cExeName_Version + ' ' + VERSION;

    StatusBar.SimpleText   := sMsgConnecting;
    ChangeToolTip(StatusBar.SimpleText);
    try
      try
        try
            Screen.cursor := crHourGlass;
            HttpUpdate.Get;
            bData := true;
        except
            on E: EHttpException do
              begin
                StatusBar.SimpleText := sMsgError +
                                     IntToStr(HttpUpdate.StatusCode) + ' ' +
                                     HttpUpdate.ReasonPhrase;
                ChangeToolTip(StatusBar.SimpleText);
              end
            else
                raise;
        end;
       finally
            if bData then
            begin
              DataIn.Seek(0, 0);
              p := DataIn.Memory;
              q := p + DataIn.Size - 1;
              r := p;
              if (p <> nil) then
                while (p < q) and (p^ <> #13) and (p^ <> #10) do
                   Inc(p);
              sData := Copy(StrPas(r), 1, p - r);
              Screen.cursor := crDefault;

              if sData=cVersion then
                sMsg := sMsgNoUpdateAvailable
              else
                sMsg := Format(sMsgUpdateAvailable,[cVersion,sData]);

                MessageBox(0,PChar(sMsg),PChar(sMsgTitle),mb_ok);
            end;
       end;
    finally
        Screen.cursor := crDefault;
        DataIn.free;
        if bData then
        begin
          StatusBar.SimpleText := '';
          ChangeToolTip(StatusBar.SimpleText);
        end;
        TimerIP.Enabled := true;
    end;
end;

procedure TFClient.chkAutoUpdateClick(Sender: TObject);
begin
  StatusBar.SimpleText :='';
  ChangeToolTip(StatusBar.SimpleText);
end;

procedure TFClient.AddIcon;
begin
  IconData.cbSize := sizeof(IconData);
  IconData.Wnd := Handle;
  IconData.uID := 100;
  IconData.uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
  IconData.uCallbackMessage := WM_USER + 1;
  //IconData.hIcon := Application.Icon.Handle;
  StrPCopy(IconData.szTip, Application.Title);
  Shell_NotifyIcon(NIM_ADD, @IconData);

  Application.ProcessMessages;
end;

procedure TFClient.GoTray;
begin
   ShowWindow(Handle, SW_HIDE);
   ShowWindow(Application.Handle, SW_HIDE);
   Application.ProcessMessages;
end;

procedure TFClient.OnSystemTry(Sender: TObject);
begin
  AddIcon;
  GoTray;
end;

procedure TFClient.ChangeToolTip(s : string);
begin
  StrPCopy(IconData.szTip, s);
  Shell_NotifyIcon(NIM_MODIFY, @IconData);
end;

procedure TFClient.WndProc(var Msg : TMessage);
var
  p : TPoint;
begin
  case Msg.Msg of
    WM_USER + 1:
    case Msg.lParam of
      WM_RBUTTONDOWN: begin
         GetCursorPos(p);
         PopupMenuTrayIcon.Popup(p.x, p.y);
      end
    end;
  end;
  inherited;
end;

procedure TFClient.popupExitClick(Sender: TObject);
begin
 TimerIp.Enabled := false;
 Close;
end;

procedure TFClient.popupOpenClick(Sender: TObject);
begin
  Application.Restore;
  Application.ProcessMessages;
  //Shell_NotifyIcon(NIM_DELETE, @IconData);
  FClient.WindowState := wsNormal;
  Application.ProcessMessages;
end;

procedure TFClient.TimerOnStartUpTimer(Sender: TObject);
begin
   TimerOnStartUp.enabled := false;
   if bStartUp then
   begin
     bStartUp := false;
     if chkAutoUpdate.State = cbChecked then
     begin
       Application.ProcessMessages;
       GoTray;
       //WriteIPAddress;
       TimerIP.Enabled:=true;
     end;
   end;
end;

procedure TFClient.mnuSetupServerURClick(Sender: TObject);
begin
  ChangeURLUpdate
end;

procedure TFClient.UpdateIP1Click(Sender: TObject);
begin
  TimerIP.enabled := false;
  UpdateData(0,false);
  TimerIP.enabled := true;
end;

procedure TFClient.MettiOffline1Click(Sender: TObject);
begin
  TimerIP.enabled := false;
  UpdateData(1,false);
  TimerIP.enabled := true;
end;

procedure TFClient.ChangeURLUpdate;
begin
  If FURLSetup = nil then
  begin
     FURLSetup := TFURLSetup.create(self);
     FURLSetup.ShowModal;
  end;
end;

end.
